atom/icon = 'icons.dmi'

battle_info
	side_one
		icon_state = "side one"
	side_two
		icon_state = "side two"
map_info/battle_map
	z = 2

battle_control
	default_map = /map_info/battle_map

// play with these!
battle_hud
	columns = 2
	slots = 4

	get_screen_loc(row, column)
		// This is just a little more complicated math to space the selections out more based on which column they are in.
		// I decided to do column%2 simply for versatility if you want to play with the columns variable.
		return "SOUTH+2-[(row-1)], CENTER - 2 + [(column)]:[column % 2 ? 0 : 16]"

mob
	icon_state = "mob"

	// what happens when you hit return
	battle_hud_selected(hud_selection/s)
		src << s.screen_text
		selection = s

	Login()
		..()
		var/mob/a = new(src)
		var/mob/b = new(src)
		var/mob/c = new(src)
		party.add(a)
		party.add(b)
		party.add(c)

		battle_hud = new(src, list("SKIP", "RUN"))
		battle_hud.hide()

		// a list for it to display
		//battle_hud = new(src, list("Test", "Test2", "test3", "Test4", "Test5", "Test6", "Test7", "test8", "test9"))
		//menu(list("test", "test2"), sx = 2, sy = 7)
	Bump(atom/a)
		..()
		if(ismob(a))
			var/mob/m = a
			battle_control.new_battle(src.party, m.party, input_mode = ALTERNATE_SIDES)

	my_turn()
		src.turn.battle() << "<b>[src]</b>'s turn!"
		selection = ""
		if(client)
			battle_hud.show()
			while(!selection)
				sleep(10)
			battle_hud.hide()

			/*if(src.turn.parent.turn < 2)

				while(!selection)
					t = alert("Would you like to end your turn?", "Turn", "No", "Yes")
				if(t == "Yes")
					return 1
			else
				var/t
				while(t != "Yes")
					t = alert("Would you like to run?", "Run", "No", "Yes")
				src.turn.run = TRUE
				return 1*/
		else
			sleep(10)
			return 1
	action()
		..()
		if(client)
			var/hud_selection/s = selection
			if(s.screen_text == "RUN")
				src.turn.run = TRUE
			else
				src.turn.battle() << "<b>[src]</b> acted ([selection])!"
		else
			src.turn.battle() << "<b>[src]</b> acted!"

	turn_ended()
		..()
		src.turn.battle() << "<b>[src]</b>'s turn ended!"

	TestMob
		New()
			..()
			var/mob/m = new(src)
			var/mob/a = new(src)
			party.add(m)
			party.add(a)