// these are just needed variables.
mob
	var
		party/party
		turn_side/turn
		skill_set/skills
		battle_hud/battle_hud
		tmp
			battle_capable = TRUE
			selection
			list/targets = list()

	// If you redefine mob/New() anywhere else, make sure you call ..() to keep things working and error-free!
	New()
		..()
		party = new(src, battle_capable)
		// each mob gets a unique tag prefixed by "M", which is stored in mob_ids.  Do with it what you will.
		tag = generate_tag("M", mob_ids)
		mob_ids += tag
		skills = new(src)
	Login()
		..()

	proc
		my_turn()

		pick_targets(skill/s)
			if(!s) return
			var/list/l = src.turn.get_enemies()
			var/list/t = s.target(l)
			if(t.len > s.max_targets)
				t.Cut(1, s.max_targets+1)
			targets = t.Copy()

		turn_ended()
			// if we should act immediately, then we need to act as soon as our turn ends
			if(src.turn.input_mode() == ACT_IMMEDIATELY || src.turn.input_mode() == ALTERNATE_SIDES)
				action()

		side_turn_ended()
			// if we should get all the team's input first, then only act once our team's turn ends
			if(src.turn.input_mode() == ALL_INPUT_FIRST)
				action()

		action()
			if(selection)
				if(istext(selection))
					for(var/skill/s in skills.skills)
						if(s.name == selection)
							skills.use(s, targets)
				else
					if(istype(selection, /hud_selection))
						var/hud_selection/s = selection
						for(var/skill/sk in skills.skills)
							if(sk.name == s.screen_text)
								skills.use(sk, targets)

		battle_hud_selected(hud_selection/s)

		//menu(list/choices, icon_state = "hud", mob/m = src, sx = 0, sy = 0, columns = 2, slots = 0, override_width = 0, override_height = 0)
		//	hud.new_menu(m, choices, icon_state, columns, slots, sx, sy, override_width, override_height)